#ifndef CAMINTERFACE_H
#define CAMINTERFACE_H

/***********************************************************
    Module Name: CamInterface.h
    Module Date: 04/14/2004
    Module Auth: John Orlando 
    Copyright (c) 2004 John Orlando  All Rights Reserved 

    Description: This file is responsible for providing the
    external interface to the CamInterface module.
    ***********************************************************/

#define NUM_PIXELS_IN_A_TRACKED_LINE 	88
#define NUM_PIXELS_IN_A_DUMP_LINE    	176
#define ACTUAL_NUM_PIXELS_IN_A_LINE		176
#define ACTUAL_NUM_LINES_IN_A_FRAME		144
#define LENGTH_OF_RUN_LENGTH_BLOCK 2
#define LENGTH_OF_LINE_BUFFER NUM_PIXELS_IN_A_DUMP_LINE

#define WAIT_FOR_VSYNC_LOW() 	while( (PIND & 0x04) != 0)
#define WAIT_FOR_VSYNC_HIGH()	while( (PIND & 0x04) == 0)

#define WAIT_FOR_HREF_LOW()		while( (PIND & 0x10) != 0)
#define WAIT_FOR_HREF_HIGH()	while( (PIND & 0x10) == 0)

#define WAIT_FOR_PCLK_LOW()		while( (PIND & 0x20) != 0)
#define WAIT_FOR_PCLK_HIGH()	while( (PIND & 0x20) == 0)

#define NUM_COLOR_STEPS       16
#define NUM_COLOR_CHANNELS	3
#define NUM_ELEMENTS_IN_COLOR_MAP (NUM_COLOR_STEPS * NUM_COLOR_CHANNELS)

#define RED_OFFSET		0
#define GREEN_OFFSET	      16
#define BLUE_OFFSET		32

extern unsigned char currentLineBuffer[];
extern unsigned char previousLineBuffer[];
extern unsigned char colorMap[];
extern unsigned char frameCount;

/* Extern functions */
extern void CamInt_init(void);
extern void CamInt_resetCam(void);
extern void CamInt_waitForNewDumpFrame(void);
extern void CamInt_waitForNewTrackingFrame(void);
extern void CamInt_acquireTrackingLine(void);
extern void CamInt_acquireDumpLine(void);

#endif

