package img.swing;

import java.awt.*;
import java.nio.*;
import java.util.logging.*;
import javax.swing.*;
import javax.swing.border.*;

import img.device.event.*;
import img.swing.*;

import img.lang.*;

public class JMessagePanel extends JPanel {

   private JTextArea messageTA;

   public JMessagePanel() {
      super(new BorderLayout());

      setBorder(new LineBorder(Color.BLACK));

      messageTA = new JTextArea(6, 20);
      messageTA.setEditable(false);

      JPanel southP = new JPanel(new FlowLayout(FlowLayout.RIGHT));
      southP.setBorder(new EtchedBorder());
      try {
         southP.add(new JButton(new ProxyAction(this, "clear", "Clear", 'c')));
      } catch(Exception e) {
      }

      JLabel titleL = new JLabel("System Messages", JLabel.CENTER);
      titleL.setFont(titleL.getFont().deriveFont(16.0f));

      add(titleL, BorderLayout.NORTH);
      add(new JScrollPane(messageTA), BorderLayout.CENTER);
      add(southP, BorderLayout.SOUTH);

      ImageSystem.DEVICE.addDataListener(new DataHandler(messageTA));
   }

   public void append(String message) {
      messageTA.append(message);
      messageTA.append("\n");
   }

   public void clear() {
      messageTA.setText("");
   }

   private static class DataHandler implements DataListener {

      private JTextArea messageTA;

      public DataHandler(JTextArea messageTA) {
         this.messageTA = messageTA;
      }

      public void ack() {
         messageTA.append("ACK\n");
      }

      public void nck() {
         messageTA.append("NCK\n");
      }

      public void version(String version) {
         messageTA.append(version);
         messageTA.append("\n");
      }

      public void frameData(ByteBuffer data) {
         //messageTA.append("Frame Data (" + (data.get() & 0xFF) + ")\n");
      }

      public void trackingData(ByteBuffer data) {
         //messageTA.append("Tracking Data\n");
      }

   }

}
